﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using EZioWM;
using Microsoft.Win32;



namespace EZioWMSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btn_WIFItest_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();
            try
            {
                p.openport(tb_IP.Text + ":" + tb_port.Text, 1);
                p.sendcommand("~V");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                p.close();
            }


        }

        private void btn_BTtest_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();
            try
            {
                p.openport(cb_comsel.SelectedItem.ToString(), 2);
                p.sendcommand("~V");
                //p.sendbuf(System.Text.Encoding.Default.GetBytes("~V\r\n"));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                p.close();
            }
        }


        private void btn_WIFIgetver_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();

            int count = 0;
            string result = "";


            try
            {
                p.openport(tb_IP.Text + ":" + tb_port.Text, 1);
                p.sendcommand("~B");
                //p.sendbuf(System.Text.Encoding.Default.GetBytes("~B\r\n"));

                System.Threading.Thread.Sleep(1000);
                while (true)
                {
                    byte[] b = p.rcvbuf();
                    if (b == null && count <= 3)
                    {
                        count++;
                        continue;
                    }

                    if (count > 3)
                        break;
                    result = result + System.Text.Encoding.Default.GetString(b, 0, b.Length);

                }


            }
            catch (Exception ex)
            {
                result = ex.ToString();
            }
            finally
            {
                p.close();
            }
            MessageBox.Show(result);

        }

        private void btn_BTgetver_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();

            string result = "";
            try
            {
                p.openport(cb_comsel.SelectedItem.ToString(), 2);
                p.sendcommand("~B");

                int count = 0;


                while (true)
                {
                    byte[] b = p.rcvbuf();
                    if (b == null && count < 3)
                    {
                        count++;
                        continue;
                    }
                    if (count >= 3)
                        break;
                    result = result + System.Text.Encoding.Default.GetString(b, 0, b.Length);

                }
            }
            catch (Exception ex)
            {
                result = ex.ToString();
            }
            finally
            {
                p.close();
            }

            MessageBox.Show(result);
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
        }

        private void menuItem1_Click_1(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string text = "Software\\Microsoft\\Bluetooth\\Serial\\Ports\\";
            RegistryKey localMachine = Registry.LocalMachine;
            RegistryKey registryKey = localMachine.OpenSubKey(text);
            if (registryKey == null)
            {
                return;
            }

            string[] subKeyNames = registryKey.GetSubKeyNames();
            foreach (string name in subKeyNames)
            {
                text = text + name+"\\";
                registryKey = localMachine.OpenSubKey(text);
                if (registryKey != null)
                {
                    string sport = (string)registryKey.GetValue("Port");
                    cb_comsel.Items.Add(sport.TrimEnd('\0'));
                }
            }


        }

        private void button1_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();
            try
            {
                
                p.openport(tb_IP.Text + ":" + tb_port.Text, 1);
                p.sendcommand("^Q40,0,0");
                p.sendcommand("^L");
                p.putimage(68,10,"\\My Documents\\godexlogo.bmp");//print image
                p.sendcommand("W154,112,5,2,M,8,5,24,0");//print qrcode
                p.sendcommand("R20,10,407,303,4,4");//print rectangle
                p.sendcommand("http://www.godexintl.com");
                p.sendcommand("AD,32,256,1,1,0,0E,http://www.godexintl.com");//print text
                p.sendcommand("E");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                p.close();
            }

        }

        private void tabPage2_Click(object sender, EventArgs e)
        {

        }

        private void btn_PrintBT_Click(object sender, EventArgs e)
        {
            GodexPrinter p = new GodexPrinter();
            try
            {
                p.openport(cb_comsel.SelectedItem.ToString(), 2);
                p.sendcommand("^Q40,0,0");
                p.sendcommand("^L");
                p.putimage(68, 10, "\\My Documents\\godexlogo.bmp");//print image
                p.sendcommand("W154,112,5,2,M,8,5,24,0");//print qrcode
                p.sendcommand("R20,10,407,303,4,4");//print rectangle
                p.sendcommand("http://www.godexintl.com");
                p.sendcommand("AD,32,256,1,1,0,0E,http://www.godexintl.com");//print text
                p.sendcommand("E");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                p.close();
            }
        }

    }
}